/////////////////////////////////////////////////////////////////////////////////////
//
//  PorownajModele.jsp
//
//  Makro suy do porwnywania danych linii (R, X, In itp. ) z dwch modeli
//  Plans, 8.09.2010
//
/////////////////////////////////////////////////////////////////////////////////////

main();

/////////////////////////////////////////////////////////////////////////////////////
//
//  Funkcja gwna
//
function main()
{
//Wczytanie modeli
  cprintf("Model referencyjny:");
	sModelR = GetFile(true, "", "", "Pliki KDM (*.kdm)|*.kdm");
	if(sModelR=="") return;
  cprintf(sModelR);
  
  cprintf("Model porwnywalny:");
	sModelP = GetFile(true, "", "", "Pliki KDM (*.kdm)|*.kdm");
	if(sModelP=="") return;
  cprintf(sModelP);

	Plans2 = new ActiveXObject("PlansEMC.Application");
  ReadDataKDM(sModelR);
  Plans2.ReadDataKDM(sModelP);
  
  
//Wybr obszaru 
  for(i=1;i<Data.N_Zon;i++) ZonArray.Get(i).Selected=0;
  ZonArray.Find("Warszawa").Selected = 1;
  ZonArray.ApplySelection();

//Wywoanie funckji porwnujacych    
  SprawdzLinie();
}


/////////////////////////////////////////////////////////////////////////////////////
//
//  Porwnanie linii
//
function SprawdzLinie()
{
//Porwnanie R,X i B2 linii  
  cprintf("");
  cprintf("Porwnanie linii");
  cprintf("");
  cprintf("Nazwa    | Pocz.    | Kon.     | Rb      | Xb      | BC      | In1    | In2    | In3    | In4");
  
  var ListaBledow = new Array;
	var i, braR, braP, linR, linP;
  var sR, sP;
  var bRoznica;
  
	
  for(i=1;i<Data.N_Lin; i++)  if(LinArray.Get(i).Mrkr>0)  //tylko z wybranego obszaru
  {
		linR = LinArray.Get(i);
    braR = BraArray.Get(linR.NrBra);
    
    braP = Plans2.BraArray.Find(braR.Name);
    if(braP==null)
    {
			ListaBledow.push( braR.Name + " - brak linii w modelu porwnywanym");
      continue;
    }
      
    if(braR.Typ!=braP.Typ)
    {
			ListaBledow.push( braR.Name + " - w modelu porwnywanym ga nie jest lini tylko transformatorem");
      continue;
    }
    linP = Plans2.LinArray.Get(braP.Indx);
    
    bRoznica=false;
    
    //nazwy
    sR = braR.Name + " | "; 
    sP = "        " + " | ";
    
    //wzy poczatkowe
    sR += braR.BegName + " | ";
    if( braR.BegName != braP.BegName )
    {
			sP += braP.BegName + " | ";
      bRoznica = true;
    }
    else
    {
			sP += "        " + " | ";
    }
 
    //wzy kocowe
    sR += braR.EndName + " | ";
    if( braR.EndName != braP.EndName )
    {
			sP += braP.EndName + " | ";
      bRoznica = true;
    }
    else
    {
			sP += "        " + " | ";
    }
     
    //Rb
    if( Math.abs( braR.Rb - braP.Rb) > 0.01 )
    {
      sR += PrintDigit(braR.Rb,7,3) + " | ";
      sP += PrintDigit(braP.Rb,7,3) + " | ";
      bRoznica = true;
    }
    else
    {
      sR += "       " + " | ";
      sP += "       " + " | ";
    }
    
    //Xb
    if( Math.abs( braR.Xb - braP.Xb) > 0.01 )
    {
      sR += PrintDigit(braR.Xb,7,3) + " | ";
      sP += PrintDigit(braP.Xb,7,3) + " | ";
      bRoznica = true;
    }
    else
    {
      sR += "       " + " | ";
      sP += "       " + " | ";
    }

    //BC
    if( Math.abs( braR.BC - braP.BC) > 0.01 )
    {
      sR += PrintDigit(braR.BC,7,2) + " | ";
      sP += PrintDigit(braP.BC,7,2) + " | ";
      bRoznica = true;
    }
    else
    {
      sR += "       " + " | ";
      sP += "       " + " | ";
    }

    //In1
		if( Math.abs( linR.In1 - linP.In1) > 0.01 )
		{
			sR += PrintDigit(linR.In1, 6, 1) + " | ";
			sP += PrintDigit(linP.In1, 6, 1) + " | ";
			bRoznica = true;
		}
		else
		{
			sR += "      " + " | ";
			sP += "      " + " | ";
		}
    
    //In2
		if( Math.abs( linR.In2 - linP.In2) > 0.01 )
		{
			sR += PrintDigit(linR.In2, 6, 1) + " | ";
			sP += PrintDigit(linP.In2, 6, 1) + " | ";
			bRoznica = true;
		}
		else
		{
			sR += "      " + " | ";
			sP += "      " + " | ";
		}

    //In3
		if( Math.abs( linR.In3 - linP.In3) > 0.01 )
		{
			sR += PrintDigit(linR.In3, 6, 1) + " | ";
			sP += PrintDigit(linP.In3, 6, 1) + " | ";
			bRoznica = true;
		}
		else
		{
			sR += "      " + " | ";
			sP += "      " + " | ";
		}

    //In4
		if( Math.abs( linR.In4 - linP.In4) > 0.01 )
		{
			sR += PrintDigit(linR.In4, 6, 1);
			sP += PrintDigit(linP.In4, 6, 1);
			bRoznica = true;
		}
		else
		{
			sR += "      ";
			sP += "      ";
		}
    
    //wypisanie
    if( bRoznica)
    {
			cprintf(sR);
			cprintf(sP);
			cprintf("");
    }
    
  }//for(i)
  
  
  //Wypisanie komunikatw zbiorczych
  for(i=0;i<ListaBledow.length;i++)
    cprintf( ListaBledow[i] );

}



/////////////////////////////////////////////////////////////////////////////////////
//
//  Wywietlenie liczby z dana precyzj
//

function PrintDigit(val,len,prec)
{
  s = val.toFixed(prec);
  while(s.length<len) s = ' ' + s;
  return s;
}